# Master thesis project - Assessment system
This repository contains the source code of driving behaviour assessment system developed as a part of my master thesis.
The system needs corresponding lesson and simulator hardware to run with. The available lessons are: Overtaking (lesson 12) and Intersections with traffic lights (lesson 10). The lessons and hardware were provided by Way As, Trondheim.

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes.

### Prerequisites

In order to compile the project you need to have Rust compiler installed. The easiest way to do so is to use a tool called Rustup: https://rustup.rs/ which will guide you through the whole installation process. On Windows the project requires to have GNU version of Rust toolchain installed and also depends on http://mingw-w64.org/ to compile included C++ libraries.

## Compiling

To compile and run the project, Cargo package manager is used (comes together with Rust compiler). To compile and run it in Debug mode: 
```
cargo run
```

To compile and run it in Release mode: 
```
cargo run --release
```

Each command assumes being run from the directory of the project.

## Running the tests

To run all included unit tests:

```
cargo test
```

## Built With

* [Rust](https://www.rust-lang.org/) - The programming language used

## License

This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details
