use ecvector::{ReadHandle, WriteHandle};
use crate::components::Component;
use crate::ecs::ShareableRefCell;
use crate::modules::Module;

use std::sync::{Arc};
use std::sync::atomic::{AtomicU64};


// Custom types
pub type GlobalTimestampMs = Arc<AtomicU64>;
pub type ComponentReadHandles = Vec<ReadHandle<u64, Component>>;
pub type ComponentWriteHandle = Arc<ShareableRefCell<WriteHandle<u64, Component>>>;
pub type Modules = Vec<(&'static str, Box<dyn Module>)>;