use simplelog::*;
use std::fs::File;

fn main() {
    // Initialize logging
    let log_config = ConfigBuilder::new().build();
    let level_filter_terminal = LevelFilter::Info;
    CombinedLogger::init(
        vec![
            TermLogger::new(level_filter_terminal,
                            log_config.clone(),
                            TerminalMode::Mixed).unwrap(),
            WriteLogger::new(LevelFilter::Info,
                             log_config.clone(),
                             File::create("assessment_system.log").unwrap()),
        ]
    ).unwrap();

    // Run the whole system
    agent_platform::build_and_run();
}