
// Config values for the whole project
// Shared memory
pub const VISUAL_SHARED_REGION_NAME: &str = "trafikkselskapet";
pub const VISUAL_SHARED_REGION_SIZE: u32 = 1024 * 1024 * 1;  // 1 MB
pub const KNOWLEDGE_GRAPH_SHARED_REGION_NAME: &str = "KnowledgeGraph";
pub const KNOWLEDGE_GRAPH_SHARED_REGION_SIZE: u32 = 1024 * 1024 * 512;  // 256 MB

// How often agent platform updates shared memory
pub const SHARED_MEMORY_UPDATE_FREQUENCY: u64 = 10;  // in ms

// Knowledge graph capacity
pub const KNOWLEDGE_GRAPH_NODE_INDEX_CAPACITY: usize = 21000;
pub const KNOWLEDGE_GRAPH_NODE_CAPACITY: usize = 20000;
pub const KNOWLEDGE_GRAPH_RELATION_INDEX_CAPACITY: usize = 20000;
pub const KNOWLEDGE_GRAPH_RELATION_CAPACITY: usize = 20000;
pub const KNOWLEDGE_GRAPH_MAX_RELATIONS: usize = 40;


// AGENTS CONFIG
// Incorrect gear agent
pub const GEAR_AGENT_ENABLE_SPEED_THRESHOLD: f32 = 15.0;  // in km/h
pub const GEAR_AGENT_THROTTLE_THRESHOLD_ACCELERATION_MODE: f32 = 0.5;

pub const GEAR_AGENT_NORMAL_RPM_LOW_BOUND: f32 = 1650.0;
pub const GEAR_AGENT_NORMAL_RPM_HIGH_BOUND: f32 = 3400.0;
pub const GEAR_AGENT_ACCELERATION_RPM_LOW_BOUND: f32 = 2000.0;
pub const GEAR_AGENT_ACCELERATION_RPM_HIGH_BOUND: f32 = 3800.0;

pub const GEAR_AGENT_MIN_GEAR: i32 = 1;
pub const GEAR_AGENT_MAX_GEAR: i32 = 6;

// Incorrect gear feedback agent
pub const GEAR_AGENT_QUEUE_LENGTH_FOR_FEEDBACK: usize = 8;
pub const GEAR_AGENT_TOO_HIGH_GEAR_TEXT: [&str; 5] = ["You need to shift down!",
    "Mind your current gear!",
    "Your gear is too high!",
    "You should shift down!",
    "Shift down please!"];
pub const GEAR_AGENT_TOO_LOW_GEAR_TEXT: [&str; 5] = ["You need to shift up!",
    "Mind your current gear!",
    "Your gear is too low!",
    "You should shift up!",
    "Shift up please!"];

// Speeding agent
pub const SPEEDING_AGENT_ENABLE_SPEED_THRESHOLD: f32 = 10.0;  // in km/h
pub const SPEEDING_AGENT_ACCELERATION_WINDOW_LENGTH: usize = 2000;  // 2s

// Speeding feedback agent
pub const SPEEDING_AGENT_QUEUE_LENGTH_FOR_FEEDBACK: usize = 6;
pub const SPEEDING_AGENT_SLIGHTLY_TEXT: [&str; 3] = ["Mind your speed!",
    "You are slightly above the speed limit!",
    "Hey! Mind the speed limit."];
pub const SPEEDING_AGENT_CONSIDERABLY_TEXT: [&str; 3] = ["You are speeding now!",
    "You should lower your speed!",
    "Please lower your speed!"];
pub const SPEEDING_AGENT_SEVERELY_TEXT: [&str; 3] = ["This is unacceptable speeding!",
    "Lower your speed immediately!",
    "Hey! You are severely speeding!"];

// Lane change agent
pub const LANE_CHANGE_AGENT_DETECTION_WINDOW_LENGTH: i64 = 1000;  // 1s

// Overtake agent
pub const OVERTAKE_AGENT_DETECTION_WINDOW_LENGTH: i64 = 20000;  // 20s
pub const OVERTAKE_AGENT_TURN_SIGNALS_DETECTION_WINDOW_LENGTH: i64 = 10000;  // 10s
pub const OVERTAKE_AGENT_REQUIRED_BLINKING_DURATION: usize = 1000;  // 1s

// Overtake feedback agent
pub const OVERTAKE_AGENT_NO_BLINK_TEXT: [&str; 3] = ["You performed an overtake without turn signals!",
    "Remember turn signals while overtaking!",
    "You did not signal while overtaking!"];
pub const OVERTAKE_AGENT_LEFT_BLINK_TEXT: [&str; 3] = ["Nice overtake but you forgot to blink right!",
    "You did not use right turn signal while overtaking!",
    "Hey! Dont forget to signal left and then right during an overtake!"];
pub const OVERTAKE_AGENT_RIGHT_BLINK_TEXT: [&str; 3] = ["Nice overtake but you forgot to blink left!",
    "You did not left turn signal while overtaking!",
    "Hey! Dont forget to signal left and then right during an overtake!"];
pub const OVERTAKE_AGENT_TWO_BLINKS_TEXT: [&str; 3] = ["Perfect! Flawless overtake with both turn signals!",
    "Great overtake! Nothing to complain about!",
    "Good! This was a very well done overtake!"];

// Car yielding feedback agent
pub const CAR_YIELDING_AGENT_RED_LIGHT_TEXT: [&str; 3] = ["You passed an intersection on a red light!",
    "Hey! Going on red light is strictly forbidden!",
    "Pay attention to traffic lights! The light was red!"];
pub const CAR_YIELDING_AGENT_NO_YIELD_TEXT: [&str; 3] = ["You did not yield to an incoming car!",
    "You were supposed to give way to a car but you did not!",
    "Hey! Remember the yielding rules! This pass was illegal!"];

// Pedestrian yielding feedback agent
pub const PEDESTRIAN_YIELDING_AGENT_CROSSWALK_TEXT: [&str; 3] = ["You drove over a crosswalk while people were still crossing!",
    "Hey! You almost hit people crossing the street!",
    "Pay attention to pedestrians on crosswalks! You have just put them in danger!"];

// Welcome text
pub const SYSTEM_INTRODUCTION_TEXT1: &str = "Hello and welcome! My name is Iris. Today, I will be your virtual driving instructor. \
    I will help you and provide feedback on your driving skills throughout the following lesson.";
pub const SYSTEM_INTRODUCTION_TEXT2: &str = "Are you ready? If yes, start up the car engine to begin the lesson.";