use proc_macro::TokenStream;
use quote::quote;
use syn;


#[proc_macro_derive(Module)]
pub fn module_macro_derive(input: TokenStream) -> TokenStream {
    // Construct a representation of Rust code as a syntax tree
    let ast = syn::parse(input).unwrap();
    impl_module_macro(&ast)
}

fn impl_module_macro(ast: &syn::DeriveInput) -> TokenStream {
    // Build the trait implementation
    let name = &ast.ident;
    let gen = quote! {
        impl Module for #name {
            fn as_any(&self) -> &dyn Any {
                self
            }
        }
    };
    gen.into()
}