mod generator;
mod turtle_parser;
mod parser_types;

use crate::parser_types::RawNode;
use crate::parser_types::RawRelation;


pub fn parse(filename: &str) -> (Vec<(String, RawNode)>, Vec<(String, RawRelation)>)
{
    return turtle_parser::parse(filename);
}

pub fn generate_types(nodes: Vec<(String, RawNode)>, relations: Vec<(String, RawRelation)>) -> String
{
    let code = generator::generate_rust_types(nodes, relations);
    return code;
}

pub fn generate_api(nodes: Vec<(String, RawNode)>, relations: Vec<(String, RawRelation)>) -> (String, String)
{
    let code = generator::generate_knowledge_graph_api(nodes, relations);
    return code;
}