
// Structs for data extracted from ontology
#[derive(Clone)]
pub struct RawNode {
    pub subclass_of: String,
    pub properties: Vec<(String, String)>
}
impl RawNode {
    pub fn new() -> RawNode {
        return RawNode { subclass_of: String::new(), properties: Vec::new() }
    }
}

#[derive(Clone)]
pub struct RawNodeProperty {
    pub data_type: String,
    pub belongs_to: String
}
impl RawNodeProperty {
    pub fn new() -> RawNodeProperty {
        return RawNodeProperty { data_type: String::new(), belongs_to: String::new() }
    }
}

#[derive(Clone)]
pub struct RawRelation {
    pub from: String,
    pub to: String,
    pub properties: Vec<(String, String)>
}
impl RawRelation {
    pub fn new() -> RawRelation {
        return RawRelation { from: String::new(), to: String::new(), properties: Vec::new() }
    }
}