﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class CrosswalkTag : MonoBehaviour
{
    [UniqueIdentifier]
    public int id = -1;
    public string name = "Untitled";

    public LaneTag belongsTo;

    [ReadOnly]
    public string pedestrianTag = "Pedestrian";
    public int pedestrianCount = 0;


    private void OnTriggerEnter(Collider other)
    {
        var go = other.gameObject;
        if (go.tag == pedestrianTag)
        {
            pedestrianCount++;
        }
    }

    private void OnTriggerExit(Collider other)
    {
        var go = other.gameObject;
        if (go.tag == pedestrianTag)
        {
            pedestrianCount--;
        }
    }
}
