﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

[CustomEditor(typeof(RoadNetwork))]
[CanEditMultipleObjects]
public class RoadNetworkEditor : Editor
{
    public override void OnInspectorGUI()
    {
        var roadNetwork = (RoadNetwork)target;

        GUILayout.BeginVertical();
        GUILayout.Label("LANES");
        if (GUILayout.Button("Show lanes")) { roadNetwork.ShowLanes(); }
        if (GUILayout.Button("Hide lanes")) { roadNetwork.HideLanes(); }
        GUILayout.EndVertical();

        GUILayout.BeginVertical();
        GUILayout.Label("ROAD SIGNS");
        if (GUILayout.Button("Show road signs")) { roadNetwork.ShowRoadSigns(); }
        if (GUILayout.Button("Hide road signs")) { roadNetwork.HideRoadSigns(); }
        GUILayout.EndVertical();

        GUILayout.BeginVertical();
        GUILayout.Label("INTERSECTIONS");
        if (GUILayout.Button("Show intersections")) { roadNetwork.ShowIntersections(); }
        if (GUILayout.Button("Hide intersections")) { roadNetwork.HideIntersections(); }
        GUILayout.EndVertical();

        GUILayout.BeginVertical();
        GUILayout.Label("CROSSWALKS");
        if (GUILayout.Button("Show crosswalks")) { roadNetwork.ShowCrosswalks(); }
        if (GUILayout.Button("Hide crosswalks")) { roadNetwork.HideCrosswalks(); }
        GUILayout.EndVertical();
    }
}

