﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RoadNetwork : MonoBehaviour
{
    public void HideLanes()
    {
        var lanes = GetComponentsInChildren<LaneTagCreator>();
        foreach (var lane in lanes)
        {
            lane.hide = true;
            lane.ForceUpdate();
        }
    }

    public void ShowLanes()
    {
        var lanes = GetComponentsInChildren<LaneTagCreator>();
        foreach (var lane in lanes)
        {
            lane.hide = false;
            lane.ForceUpdate();
        }
    }

    public void HideRoadSigns()
    {
        var signs = GetComponentsInChildren<RoadSignTag>();
        foreach (var sign in signs)
        {
            var renderer = sign.GetComponent<Renderer>();
            if (renderer != null)
            {
                renderer.enabled = false;
            }
        }
    }

    public void ShowRoadSigns()
    {
        var signs = GetComponentsInChildren<RoadSignTag>();
        foreach (var sign in signs)
        {
            var renderer = sign.GetComponent<Renderer>();
            if (renderer != null)
            {
                renderer.enabled = true;
            }
        }
    }

    public void HideIntersections()
    {
        var intersections = GetComponentsInChildren<IntersectionTag>();
        foreach (var intersection in intersections)
        {
            var renderer1 = intersection.GetComponent<Renderer>();
            if (renderer1 != null)
            {
                renderer1.enabled = false;
            }

            var renderer2 = intersection.transform.Find("car-trigger").GetComponent<Renderer>();
            if (renderer2 != null)
            {
                renderer2.enabled = false;
            }


            var renderer3 = intersection.transform.Find("ego-trigger").GetComponent<Renderer>();
            if (renderer3 != null)
            {
                renderer3.enabled = false;
            }
        }
    }

    public void ShowIntersections()
    {
        var intersections = GetComponentsInChildren<IntersectionTag>();
        foreach (var intersection in intersections)
        {
            var renderer1 = intersection.GetComponent<Renderer>();
            if (renderer1 != null)
            {
                renderer1.enabled = true;
            }

            var renderer2 = intersection.transform.Find("car-trigger").GetComponent<Renderer>();
            if (renderer2 != null)
            {
                renderer2.enabled = true;
            }

            var renderer3 = intersection.transform.Find("ego-trigger").GetComponent<Renderer>();
            if (renderer3 != null)
            {
                renderer3.enabled = true;
            }
        }
    }

    public void HideCrosswalks()
    {
        var signs = GetComponentsInChildren<CrosswalkTag>();
        foreach (var sign in signs)
        {
            var renderer = sign.GetComponent<Renderer>();
            if (renderer != null)
            {
                renderer.enabled = false;
            }
        }
    }

    public void ShowCrosswalks()
    {
        var signs = GetComponentsInChildren<CrosswalkTag>();
        foreach (var sign in signs)
        {
            var renderer = sign.GetComponent<Renderer>();
            if (renderer != null)
            {
                renderer.enabled = true;
            }
        }
    }
}
