﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum RoadSignType {
    NoEntrySign,
    PriorityRoadSign,
    SpeedLimitSign,
    StopSign,
    YieldSign
}

public class RoadSignTag : MonoBehaviour
{
    [UniqueIdentifier]
    public int id = -1;
    public RoadSignType type;

    [Serializable]
    public struct Property
    {
        public string name;
        public string value;
    }
    public Property[] properties;

    public LaneTag belongsTo;


    public string GetProperty(string name)
    {
        foreach (var property in properties)
        {
            if (property.name == name)
            {
                return property.value;
            } 
        }

        return string.Empty;
    }
}
