﻿using System;
using System.Collections;
using System.Collections.Generic;
using TrafficLightNew;
using UnityEngine;


public class TrafficLightsTag : MonoBehaviour
{
    [UniqueIdentifier]
    public int id = -1;
    public string name = "Untitled";

    public TrafficLightNew.TrafficLightSystem trafficLightSystem;

    [Serializable]
    public struct Light2LaneTag
    {
        public trafficLightDirections trafficLightDirection;
        public LaneTag lane;
    }
    public Light2LaneTag[] direction2LaneMapping;


    public List<LaneTag> GetActiveLanes()
    {
        var lanes = new List<LaneTag>();
        if (trafficLightSystem.activeLights.Count == 0)
        {
            return lanes;
        }

        // Find the right mapping
        var directions = trafficLightSystem.activeLights;
        foreach (var direction in directions)
        {
            foreach (var mapping in direction2LaneMapping)
            {
                if (mapping.trafficLightDirection == direction)
                {
                    lanes.Add(mapping.lane);
                }
            }
        }

        return lanes;
    }
}
